//----------------------------------------------------------------
//
// clock.asm,              1997 (c) RC Module Ltd.
// NeuroChip NM6403, clock function realisation file
//
//----------------------------------------------------------------


import from macros640x;

global _clock : label;
global clock_initialize : label;

begin text
.if (.nm64revision == 3);

    // function initialize timer registers and PSW with zero value
    // before the 'main' functions
<clock_initialize>
    with gr7 = false;
    START_TIMER1( 1 );
//	pswr set 0003_0000h;
    t1 = gr7;           // timers count interval (+0, -0)	6405: ,  .  0
    return;

end text;

    // called before main function.

begin init
        // call to initializing functions before the call to 'main'
    call clock_initialize;
end init;

begin text

    // extern "C" clock_t clock( void );
    // _clock
    // return user timer (T1) value
<_clock>

    delayed return;
    gr7 = t1;
    nul 32;
    // end of delayed return

.endif;
end text;

