//==============================================================================
//  Component:
//      STD (C++ Standard Library)
//
//  Library:
//      $KW; $FN; $EKW;
//      $KW; $Own; $Ver; $ChkD; $EKW;
//
//  Purpose:
//
//  Copyright (C) 1998-2001, Interstron, Ltd.
//  All rights reserved.
//==###=========================================================================
#include <cstdlib>
#include <new>

extern std::new_handler _current_new_handler;

void*
operator new (std::size_t _N) throw(std::bad_alloc)
{
    void* _P;
    while (!(_P = std::malloc(_N))) {
        if (!_current_new_handler) {
            throw std::bad_alloc();
        }
        _current_new_handler();
    }
    return _P;
}

//==###=========================================================================
//  End of module:
//      $KW; $FN; $EKW;
//==============================================================================
