//==============================================================================
//  Component:
//      STD (C++ Standard Library)
//
//  Library:
//      $KW; $FN; $EKW;
//      $KW; $Own; $Ver; $ChkD; $EKW;
//
//  Purpose:
//
//  Copyright (C) 1998-2001, Interstron, Ltd.
//  All rights reserved.
//==###=========================================================================
#include <cstdlib>
#include <new>

std::new_handler _current_new_handler = 0;  

namespace std {

std::new_handler
set_new_handler(std::new_handler _H) throw()
{
    std::new_handler _C = _current_new_handler;
    _current_new_handler = _H;
    return _C;
}

} // namespace std;
//==###=========================================================================
//  End of module:
//      $KW; $FN; $EKW;
//==============================================================================
