global DAdd :label;


extern DFrExp           :label;
extern DResult          :label;
extern RShift64         :label;
extern FPIEEE_Signal    :label;


import FPIEEE_FLAGS_DEF from rtmacro;

FPIEEE_FLAGS_DEF();


begin text

<DAdd>
    ar5 = sp;
    push ar6, gr6;
    ar6 = ar5;
    push ar1, gr1;
    ar1, gr1 = [ ar5 -= 4 ];    //  
    push ar0, gr0;
    ar0, gr0 = [ --ar5 ];       //  
    push ar2, gr2;
    push ar3, gr3;
    push ar4, gr4;
    push ar5, gr5;
    sp += 2;
    push ar0, gr0;
    call DFrExp;
    pop ar2, gr2;       //   
    pop ar3, gr3;       //     

    push ar1,gr1;	// old - sp += 2; correct silicon bug 4.
    push ar1, gr1;
    call DFrExp;
    pop ar4, gr4;       //   
    pop ar0, gr0;       //     
    with gr3 - gr0;     //  
    if u>= skip L1;     //       
                        //   
        //   
    ar1, gr1 = ar2, gr2;
    ar2, gr2 = ar4, gr4;
    ar4, gr4 = ar1, gr1;
    ar1, gr1 = ar3, gr3;
    ar3, gr3 = ar0, gr0;
    ar0, gr0 = ar1, gr1;
<L1>
    gr7 = 7ffh;
    gr7 = 32
        with gr3 - gr7;
    if =0 delayed skip Abnormal
        with gr0 = gr3 - gr0;   //     
    with gr0 - gr7;
    nul;
    // cond. skip Abnormal
    if u< skip Adj0;
    gr0 -= gr7;
    with gr0 - gr7;
    if u< skip Adj1;

        //     64
    gr0 = ar4;
    gr4 = gr4 or gr0;
    delayed skip Sign
        with gr0 = false;
    gr1 = false;
    gr5 = false;

<Adj1>  //   32  64
    push ar4, gr4;
    call RShift64
        with gr7 = gr0;
    delayed skip Sign
        with gr5 = false;
    pop ar1, gr1;
    gr0 = ar1;

<Adj0>  //   0  31
    push ar4, gr4;
    call RShift64
        with gr7 = gr0;
    gr1 = ar4
        with gr7 = false;
    ar1 = gr7;
    push ar1, gr1;
    call RShift64
        with gr7 = gr0;
    pop ar5, gr5;
    gr0 = ar5;
    pop ar5, gr5;
    gr1 = ar5;

<Sign>
    gr6 = ar3;
    gr7 = ar0;
    with gr6 xor gr7;
    if < skip Sub;

        // 
    gr7 = ar2;
    delayed call DResult
        with gr1 = gr7 + gr1;
    gr2 = gr2 + gr5 + carry;
    with gr5 = gr6;  // 
    // call DResult;
    skip Ret;

<Sub>
    gr7 = false;
    with -gr4;
    gr7 = ar2
        with gr0 = gr7 - gr0 - 1 + carry;
    gr1 = gr7 - gr1 - 1 + carry;
    gr2 = gr2 - gr5 - 1 + carry;
    if >= delayed skip L2
        with gr7 = false;
    with -gr4;
    nul;
    // cond. skip L2
    gr0 = gr7 - gr0 - 1 + carry;
    gr1 = gr7 - gr1 - 1 + carry;
    gr2 = gr7 - gr2 - 1 + carry;
    gr6 = -gr6;
<L2>
    call DResult
        with gr5 = gr6;

<Ret>
    [ ar6 -= 4 ] = ar0, gr0;
    pop ar5, gr5;
    pop ar4, gr4;
    pop ar3, gr3;
    pop ar2, gr2;
    pop ar0, gr0;
    pop ar1, gr1;
    pop ar6, gr6;
    return;

<Abnormal>
    with gr0;
    if =0 delayed skip BothAbnormal;
    gr7 = ar2;
    gr7 = gr7 or gr2;
    // cond. skip BothAbnormal
    if <>0 skip NaN;

<Inf>   //   - 
    gr0 = ar3
        with gr1 = false;
    ar0 = gr1
        with gr0 >>= 31;
    gr7 = 7ff00000h;
    delayed skip Ret
        with gr0 <<= 31;
    gr0 = gr0 or gr7;
    nul;
    // skip Ret;

<BothAbnormal>
    gr4 = ar4
        with gr7 = gr7 or gr4;
    with gr7 or gr4;
    if <>0 skip NaN;

        //  .  
    gr0 = ar3;
    gr1 = ar0;
    with gr0 xor gr1;
    if < skip Invalid;  //    
    skip Inf;
<NaN>
    delayed skip Ret;
    gr0 = true;
    ar0 = gr0;
    // skip Ret;
<Invalid>
    gr7 = _FPIEEE_Invalid;
    call FPIEEE_Signal;
    delayed skip Ret;
    gr0 = true;
    ar0 = gr0;
    // skip Ret;

end text;
