//----------------------------------------------------------------
//
// NeuroChip NM6403, C runtime library
// 1997-1999 (c) RC Module Inc.
// mbstowcs.c,
//
//----------------------------------------------------------------

#include <stdlib.h>

#ifdef __cplusplus
extern "C"
#endif
size_t mbstowcs (wchar_t *pwcs, const char *s, size_t n)
{
	int i;

	for (i=0; i<n && *s; i++)
		*pwcs++ = *s++;

	if (i<n)
		*pwcs = 0;

	return i;
}

